/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbbr;

import util.Atribut;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author mira
 */
public class DBBroker {
    
    
    static Connection con;
    static Statement st ;
    static DBBroker instance;
    public DBBroker() {
        
    }

    public static DBBroker getInstance(){
        if (instance==null){
            
            instance = new DBBroker();
            instance.poveziSe();
        }

        return instance;

    }

    private void poveziSe() {
        try {
            String databaseIP = "localhost";
                String port = "3306";
                String driver = "com.mysql.jdbc.Driver";
                String userName = "root";
                String password = "root";
                String databaseName="njt";
                instance = new DBBroker();
                String databaseURL =  "jdbc:mysql://"+databaseIP+":"+port+"/"+databaseName;
                con = DriverManager.getConnection(databaseURL,userName,password);
                
                
                
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    
        public List<Atribut> vratiMetaPodatkeTabele(String nazivTabele) throws SQLException{
            
            
            String upit = "Select * from "+nazivTabele;
            Statement st = con.createStatement();
            ResultSet rs = st.executeQuery(upit);
            
            ResultSetMetaData rsmd = rs.getMetaData();
            
            List<Atribut> listaAtributa = new ArrayList<>();
            
            for(int i=1;i<rsmd.getColumnCount()+1;i++){
                Atribut atribut = new Atribut();
                atribut.setNaziv(rsmd.getColumnName(i));
                atribut.setTip(getJavaType(rsmd.getColumnType(i)));
                listaAtributa.add(atribut);
            }
            
            return listaAtributa;
            
        }
    
        
    
        public static String getJavaType(int colType) {
        
            switch(colType){
                
                case Types.CHAR: return "String";
                case Types.VARCHAR: return "String";
                case Types.LONGNVARCHAR: return "String";
                case Types.NVARCHAR: return "String";
                case Types.LONGVARCHAR: return "String";
                case Types.SMALLINT: return "Boolean";
                case Types.NUMERIC: return "Double";
                case Types.DECIMAL: return "Double";
                case Types.DOUBLE: return "Double";
                case Types.INTEGER: return "Integer";
                case Types.BIGINT: return "Long";
                case Types.FLOAT: return "Float";
                case Types.REAL: return "Float";
                case Types.DATE: return "java.util.Date";
                case Types.TIME: return "java.sql.Time";
                case Types.TIMESTAMP: return "java.util.Date";
            }
            
        return "UnknownType";
    }

    
    
}
